Extract query related logical units from cmdlib
[ganeti-local] / Makefile.am
1 # Ganeti makefile
2 # - Indent with tabs only.
3 # - Keep files sorted; one line per file.
4 # - Directories in lib/ must have their own *dir variable (see hypervisor).
5 # - All directories must be listed DIRS.
6 # - Use autogen.sh to generate Makefile.in and configure script.
7
8 # Automake doesn't export these variables before version 1.10.
9 abs_top_builddir = @abs_top_builddir@
10 abs_top_srcdir = @abs_top_srcdir@
11
12 # Helper values for calling builtin functions
13 empty :=
14 space := $(empty) $(empty)
15 comma := ,
16
17 # Helper function to strip src/ and test/hs/ from a list
18 strip_hsroot = $(patsubst src/%,%,$(patsubst test/hs/%,%,$(1)))
19
20 # Use bash in order to be able to use pipefail
21 SHELL=/bin/bash
22
23 ACLOCAL_AMFLAGS = -I autotools
24 BUILD_BASH_COMPLETION = $(top_srcdir)/autotools/build-bash-completion
25 RUN_IN_TEMPDIR = $(top_srcdir)/autotools/run-in-tempdir
26 CHECK_PYTHON_CODE = $(top_srcdir)/autotools/check-python-code
27 CHECK_HEADER = $(top_srcdir)/autotools/check-header
28 CHECK_MAN_DASHES = $(top_srcdir)/autotools/check-man-dashes
29 CHECK_MAN_REFERENCES = $(top_srcdir)/autotools/check-man-references
30 CHECK_MAN_WARNINGS = $(top_srcdir)/autotools/check-man-warnings
31 CHECK_VERSION = $(top_srcdir)/autotools/check-version
32 CHECK_NEWS = $(top_srcdir)/autotools/check-news
33 CHECK_IMPORTS = $(top_srcdir)/autotools/check-imports
34 DOCPP = $(top_srcdir)/autotools/docpp
35 REPLACE_VARS_SED = autotools/replace_vars.sed
36 CONVERT_CONSTANTS = $(top_srcdir)/autotools/convert-constants
37 BUILD_RPC = $(top_srcdir)/autotools/build-rpc
38 SHELL_ENV_INIT = autotools/shell-env-init
39
40 # Note: these are automake-specific variables, and must be named after
41 # the directory + 'dir' suffix
42 clientdir = $(pkgpythondir)/client
43 cmdlibdir = $(pkgpythondir)/cmdlib
44 hypervisordir = $(pkgpythondir)/hypervisor
45 httpdir = $(pkgpythondir)/http
46 masterddir = $(pkgpythondir)/masterd
47 confddir = $(pkgpythondir)/confd
48 rapidir = $(pkgpythondir)/rapi
49 serverdir = $(pkgpythondir)/server
50 watcherdir = $(pkgpythondir)/watcher
51 impexpddir = $(pkgpythondir)/impexpd
52 utilsdir = $(pkgpythondir)/utils
53 toolsdir = $(pkglibdir)/tools
54 iallocatorsdir = $(pkglibdir)/iallocators
55 pytoolsdir = $(pkgpythondir)/tools
56 docdir = $(datadir)/doc/$(PACKAGE)
57 myexeclibdir = $(pkglibdir)
58
59 # Delete output file if an error occurred while building it
60 .DELETE_ON_ERROR:
61
62 HS_DIRS = \
63         src \
64         src/Ganeti \
65         src/Ganeti/Block \
66         src/Ganeti/Block/Drbd \
67         src/Ganeti/Confd \
68         src/Ganeti/Curl \
69         src/Ganeti/DataCollectors \
70         src/Ganeti/HTools \
71         src/Ganeti/HTools/Backend \
72         src/Ganeti/HTools/Program \
73         src/Ganeti/Hypervisor \
74         src/Ganeti/Hypervisor/Xen \
75         src/Ganeti/Monitoring \
76         src/Ganeti/Query \
77         test/hs \
78         test/hs/Test \
79         test/hs/Test/Ganeti \
80         test/hs/Test/Ganeti/Block \
81         test/hs/Test/Ganeti/Block/Drbd \
82         test/hs/Test/Ganeti/Confd \
83         test/hs/Test/Ganeti/HTools \
84         test/hs/Test/Ganeti/HTools/Backend \
85         test/hs/Test/Ganeti/Hypervisor \
86         test/hs/Test/Ganeti/Hypervisor/Xen \
87         test/hs/Test/Ganeti/Query
88
89 # Haskell directories without the roots (src, test/hs)
90 HS_DIRS_NOROOT = $(filter-out src,$(filter-out test/hs,$(HS_DIRS)))
91
92 DIRS = \
93         $(HS_DIRS) \
94         autotools \
95         daemons \
96         devel \
97         devel/data \
98         doc \
99         doc/css \
100         doc/examples \
101         doc/examples/gnt-debug \
102         doc/examples/hooks \
103         test/data/htools \
104         test/data/htools/rapi \
105         test/hs/shelltests \
106         lib \
107         lib/build \
108         lib/client \
109         lib/cmdlib \
110         lib/confd \
111         lib/http \
112         lib/hypervisor \
113         lib/impexpd \
114         lib/masterd \
115         lib/rapi \
116         lib/server \
117         lib/tools \
118         lib/utils \
119         lib/watcher \
120         man \
121         qa \
122         test \
123         test/data \
124         test/data/bdev-rbd \
125         test/data/ovfdata \
126         test/data/ovfdata/other \
127         test/py \
128         tools
129
130 ALL_APIDOC_HS_DIRS = \
131         $(APIDOC_HS_DIR) \
132         $(patsubst %,$(APIDOC_HS_DIR)/%,$(call strip_hsroot,$(HS_DIRS_NOROOT)))
133
134 BUILDTIME_DIR_AUTOCREATE = \
135         scripts \
136         $(APIDOC_DIR) \
137         $(ALL_APIDOC_HS_DIRS) \
138         $(APIDOC_PY_DIR) \
139         $(COVERAGE_DIR) \
140         $(COVERAGE_HS_DIR) \
141         $(COVERAGE_PY_DIR) \
142         .hpc
143
144 BUILDTIME_DIRS = \
145         $(BUILDTIME_DIR_AUTOCREATE) \
146         doc/html \
147         doc/man-html
148
149 DIRCHECK_EXCLUDE = \
150         $(BUILDTIME_DIRS) \
151         ganeti-[0-9]*.[0-9]*.[0-9]* \
152         doc/html/_* \
153         doc/man-html/_* \
154         autom4te.cache
155
156 # some helper vars
157 COVERAGE_DIR = doc/coverage
158 COVERAGE_PY_DIR = $(COVERAGE_DIR)/py
159 COVERAGE_HS_DIR = $(COVERAGE_DIR)/hs
160 APIDOC_DIR = doc/api
161 APIDOC_PY_DIR = $(APIDOC_DIR)/py
162 APIDOC_HS_DIR = $(APIDOC_DIR)/hs
163
164 MAINTAINERCLEANFILES = \
165         $(maninput) \
166         doc/install-quick.rst \
167         doc/news.rst \
168         doc/upgrade.rst \
169         vcs-version
170
171 maintainer-clean-local:
172         rm -rf $(BUILDTIME_DIRS)
173
174 CLEANFILES = \
175         $(addsuffix /*.py[co],$(DIRS)) \
176         $(addsuffix /*.hi,$(HS_DIRS)) \
177         $(addsuffix /*.o,$(HS_DIRS)) \
178         $(PYTHON_BOOTSTRAP) \
179         epydoc.conf \
180         $(REPLACE_VARS_SED) \
181         $(SHELL_ENV_INIT) \
182         daemons/daemon-util \
183         daemons/ganeti-cleaner \
184         devel/squeeze-amd64.tar.gz \
185         devel/squeeze-amd64.conf \
186         $(mandocrst) \
187         doc/manpages-enabled.rst \
188         $(BUILT_EXAMPLES) \
189         doc/examples/bash_completion \
190         doc/examples/bash_completion-debug \
191         lib/_generated_rpc.py \
192         $(man_MANS) \
193         $(manhtml) \
194         tools/kvm-ifup \
195         tools/users-setup \
196         tools/vcluster-setup \
197         stamp-directories \
198         stamp-srclinks \
199         $(nodist_pkgpython_PYTHON) \
200         $(HS_ALL_PROGS) $(HS_BUILT_SRCS) \
201         $(HS_BUILT_TEST_HELPERS) \
202         src/ganeti-confd \
203         src/ganeti-mond \
204         .hpc/*.mix src/*.tix test/hs/*.tix \
205         doc/hs-lint.html
206
207 GENERATED_FILES = \
208         $(built_base_sources) \
209         $(BUILT_PYTHON_SOURCES) \
210         $(PYTHON_BOOTSTRAP)
211
212 HS_GENERATED_FILES =
213 if WANT_HTOOLS
214 HS_GENERATED_FILES += $(HS_PROGS)
215 if ENABLE_CONFD
216 HS_GENERATED_FILES += src/hconfd src/ganeti-confd
217 endif
218
219 if ENABLE_MOND
220 HS_GENERATED_FILES += src/ganeti-mond
221 endif
222 endif
223
224 built_base_sources = \
225         stamp-directories \
226         stamp-srclinks
227
228 built_python_base_sources = \
229         lib/_autoconf.py \
230         lib/_vcsversion.py
231
232 BUILT_PYTHON_SOURCES = \
233         $(built_python_base_sources) \
234         lib/_generated_rpc.py
235
236 # Generating the RPC wrappers depends on many things, so make sure
237 # it's built at the end of the built sources
238 lib/_generated_rpc.py: | $(built_base_sources) $(built_python_base_sources)
239
240 # these are all built from the underlying %.in sources
241 BUILT_EXAMPLES = \
242         doc/examples/ganeti-kvm-poweroff.initd \
243         doc/examples/ganeti.cron \
244         doc/examples/ganeti.initd \
245         doc/examples/ganeti-master-role.ocf \
246         doc/examples/ganeti-node-role.ocf \
247         doc/examples/gnt-config-backup \
248         doc/examples/hooks/ipsec
249
250 nodist_pkgpython_PYTHON = \
251         $(BUILT_PYTHON_SOURCES)
252
253 noinst_PYTHON = \
254         lib/build/__init__.py \
255         lib/build/shell_example_lexer.py \
256         lib/build/sphinx_ext.py
257
258 pkgpython_PYTHON = \
259         lib/__init__.py \
260         lib/asyncnotifier.py \
261         lib/backend.py \
262         lib/bdev.py \
263         lib/bootstrap.py \
264         lib/cli.py \
265         lib/compat.py \
266         lib/config.py \
267         lib/constants.py \
268         lib/daemon.py \
269         lib/errors.py \
270         lib/hooksmaster.py \
271         lib/ht.py \
272         lib/jqueue.py \
273         lib/jstore.py \
274         lib/locking.py \
275         lib/luxi.py \
276         lib/mcpu.py \
277         lib/netutils.py \
278         lib/objects.py \
279         lib/opcodes.py \
280         lib/outils.py \
281         lib/ovf.py \
282         lib/pathutils.py \
283         lib/qlang.py \
284         lib/query.py \
285         lib/rpc.py \
286         lib/rpc_defs.py \
287         lib/runtime.py \
288         lib/serializer.py \
289         lib/ssconf.py \
290         lib/ssh.py \
291         lib/storage.py \
292         lib/uidpool.py \
293         lib/vcluster.py \
294         lib/network.py \
295         lib/workerpool.py
296
297 client_PYTHON = \
298         lib/client/__init__.py \
299         lib/client/gnt_backup.py \
300         lib/client/gnt_cluster.py \
301         lib/client/gnt_debug.py \
302         lib/client/gnt_group.py \
303         lib/client/gnt_instance.py \
304         lib/client/gnt_job.py \
305         lib/client/gnt_node.py \
306         lib/client/gnt_network.py \
307         lib/client/gnt_os.py \
308         lib/client/gnt_storage.py
309
310 cmdlib_PYTHON = \
311         lib/cmdlib/__init__.py \
312         lib/cmdlib/common.py \
313         lib/cmdlib/base.py \
314         lib/cmdlib/cluster.py \
315         lib/cmdlib/group.py \
316         lib/cmdlib/node.py \
317         lib/cmdlib/instance.py \
318         lib/cmdlib/instance_utils.py \
319         lib/cmdlib/backup.py \
320         lib/cmdlib/query.py \
321         lib/cmdlib/tags.py \
322         lib/cmdlib/network.py \
323         lib/cmdlib/test.py
324
325 hypervisor_PYTHON = \
326         lib/hypervisor/__init__.py \
327         lib/hypervisor/hv_base.py \
328         lib/hypervisor/hv_chroot.py \
329         lib/hypervisor/hv_fake.py \
330         lib/hypervisor/hv_kvm.py \
331         lib/hypervisor/hv_lxc.py \
332         lib/hypervisor/hv_xen.py
333
334 rapi_PYTHON = \
335         lib/rapi/__init__.py \
336         lib/rapi/baserlib.py \
337         lib/rapi/client.py \
338         lib/rapi/client_utils.py \
339         lib/rapi/connector.py \
340         lib/rapi/rlib2.py \
341         lib/rapi/testutils.py
342
343 http_PYTHON = \
344         lib/http/__init__.py \
345         lib/http/auth.py \
346         lib/http/client.py \
347         lib/http/server.py
348
349 confd_PYTHON = \
350         lib/confd/__init__.py \
351         lib/confd/client.py
352
353 masterd_PYTHON = \
354         lib/masterd/__init__.py \
355         lib/masterd/iallocator.py \
356         lib/masterd/instance.py
357
358 impexpd_PYTHON = \
359         lib/impexpd/__init__.py
360
361 watcher_PYTHON = \
362         lib/watcher/__init__.py \
363         lib/watcher/nodemaint.py \
364         lib/watcher/state.py
365
366 server_PYTHON = \
367         lib/server/__init__.py \
368         lib/server/masterd.py \
369         lib/server/noded.py \
370         lib/server/rapi.py
371
372 pytools_PYTHON = \
373         lib/tools/__init__.py \
374         lib/tools/burnin.py \
375         lib/tools/ensure_dirs.py \
376         lib/tools/node_cleanup.py \
377         lib/tools/node_daemon_setup.py \
378         lib/tools/prepare_node_join.py
379
380 utils_PYTHON = \
381         lib/utils/__init__.py \
382         lib/utils/algo.py \
383         lib/utils/filelock.py \
384         lib/utils/hash.py \
385         lib/utils/io.py \
386         lib/utils/log.py \
387         lib/utils/lvm.py \
388         lib/utils/mlock.py \
389         lib/utils/nodesetup.py \
390         lib/utils/process.py \
391         lib/utils/retry.py \
392         lib/utils/text.py \
393         lib/utils/wrapper.py \
394         lib/utils/x509.py
395
396 docinput = \
397         doc/conf.py \
398         doc/css/style.css \
399         doc/admin.rst \
400         doc/cluster-merge.rst \
401         doc/design-2.0.rst \
402         doc/design-2.1.rst \
403         doc/design-2.2.rst \
404         doc/design-2.3.rst \
405         doc/design-2.4.rst \
406         doc/design-2.5.rst \
407         doc/design-2.6.rst \
408         doc/design-2.7.rst \
409         doc/design-autorepair.rst \
410         doc/design-bulk-create.rst \
411         doc/design-chained-jobs.rst \
412         doc/design-cpu-pinning.rst \
413         doc/design-device-uuid-name.rst \
414         doc/design-draft.rst \
415         doc/design-htools-2.3.rst \
416         doc/design-http-server.rst \
417         doc/design-impexp2.rst \
418         doc/design-lu-generated-jobs.rst \
419         doc/design-linuxha.rst \
420         doc/design-multi-reloc.rst \
421         doc/design-network.rst \
422         doc/design-node-add.rst \
423         doc/design-oob.rst \
424         doc/design-ovf-support.rst \
425         doc/design-opportunistic-locking.rst \
426         doc/design-partitioned.rst \
427         doc/design-query-splitting.rst \
428         doc/design-query2.rst \
429         doc/design-reason-trail.rst \
430         doc/design-resource-model.rst \
431         doc/design-restricted-commands.rst \
432         doc/design-shared-storage.rst \
433         doc/design-monitoring-agent.rst \
434         doc/design-virtual-clusters.rst \
435         doc/design-x509-ca.rst \
436         doc/design-hroller.rst \
437         doc/design-storagetypes.rst \
438         doc/devnotes.rst \
439         doc/glossary.rst \
440         doc/hooks.rst \
441         doc/iallocator.rst \
442         doc/index.rst \
443         doc/install-quick.rst \
444         doc/install.rst \
445         doc/locking.rst \
446         doc/manpages-disabled.rst \
447         doc/move-instance.rst \
448         doc/news.rst \
449         doc/ovfconverter.rst \
450         doc/rapi.rst \
451         doc/security.rst \
452         doc/upgrade.rst \
453         doc/virtual-cluster.rst \
454         doc/walkthrough.rst
455
456 # Generates file names such as "doc/man-gnt-instance.rst"
457 mandocrst = $(addprefix doc/man-,$(notdir $(manrst)))
458
459 # Haskell programs to be installed in $PREFIX/bin
460 HS_BIN_PROGS=src/htools
461
462 # Haskell programs to be installed in the MYEXECLIB dir
463 if ENABLE_MOND
464 HS_MYEXECLIB_PROGS=src/mon-collector
465 else
466 HS_MYEXECLIB_PROGS=
467 endif
468
469 # Haskell programs to be compiled by "make really-all"
470 HS_COMPILE_PROGS= \
471         src/ganeti-mond \
472         src/hconfd \
473         src/rpc-test
474
475 # All Haskell non-test programs to be compiled but not automatically installed
476 HS_PROGS = $(HS_BIN_PROGS) $(HS_MYEXECLIB_PROGS)
477
478 HS_BIN_ROLES = harep hbal hscan hspace hinfo hcheck hroller
479 HS_HTOOLS_PROGS = $(HS_BIN_ROLES) hail
480
481 HS_ALL_PROGS = \
482         $(HS_PROGS) \
483         test/hs/hpc-htools \
484         test/hs/hpc-mon-collector \
485         test/hs/htest \
486         $(HS_COMPILE_PROGS)
487
488 HS_PROG_SRCS = $(patsubst %,%.hs,$(HS_ALL_PROGS))
489 HS_BUILT_TEST_HELPERS = $(HS_BIN_ROLES:%=test/hs/%) test/hs/hail
490
491 HFLAGS = \
492         -O -Wall -Werror -isrc \
493         -fwarn-monomorphism-restriction \
494         -fwarn-tabs \
495         $(GHC_BYVERSION_FLAGS)
496
497 # extra flags that can be overriden on the command line (e.g. -Wwarn, etc.)
498 HEXTRA =
499 # internal extra flags (used for test/hs/htest mainly)
500 HEXTRA_INT =
501 # exclude options for coverage reports
502 HPCEXCL = --exclude Main \
503         --exclude Ganeti.Constants \
504         --exclude Ganeti.HTools.QC \
505         --exclude Ganeti.THH \
506         --exclude Ganeti.Version \
507         --exclude Test.Ganeti.Attoparsec \
508         --exclude Test.Ganeti.TestCommon \
509         --exclude Test.Ganeti.TestHTools \
510         --exclude Test.Ganeti.TestHelper \
511         --exclude Test.Ganeti.TestImports \
512         $(patsubst src.%,--exclude Test.%,$(subst /,.,$(patsubst %.hs,%, $(HS_LIB_SRCS))))
513
514 HS_LIB_SRCS = \
515         src/Ganeti/Block/Drbd/Types.hs \
516         src/Ganeti/Block/Drbd/Parser.hs \
517         src/Ganeti/BasicTypes.hs \
518         src/Ganeti/Common.hs \
519         src/Ganeti/Compat.hs \
520         src/Ganeti/Confd/Client.hs \
521         src/Ganeti/Confd/Server.hs \
522         src/Ganeti/Confd/Types.hs \
523         src/Ganeti/Confd/Utils.hs \
524         src/Ganeti/Config.hs \
525         src/Ganeti/Curl/Multi.hs \
526         src/Ganeti/Daemon.hs \
527         src/Ganeti/DataCollectors/CLI.hs \
528         src/Ganeti/DataCollectors/Drbd.hs \
529         src/Ganeti/DataCollectors/Program.hs \
530         src/Ganeti/DataCollectors/Types.hs \
531         src/Ganeti/Errors.hs \
532         src/Ganeti/HTools/Backend/IAlloc.hs \
533         src/Ganeti/HTools/Backend/Luxi.hs \
534         src/Ganeti/HTools/Backend/Rapi.hs \
535         src/Ganeti/HTools/Backend/Simu.hs \
536         src/Ganeti/HTools/Backend/Text.hs \
537         src/Ganeti/HTools/CLI.hs \
538         src/Ganeti/HTools/Cluster.hs \
539         src/Ganeti/HTools/Container.hs \
540         src/Ganeti/HTools/ExtLoader.hs \
541         src/Ganeti/HTools/Graph.hs \
542         src/Ganeti/HTools/Group.hs \
543         src/Ganeti/HTools/Instance.hs \
544         src/Ganeti/HTools/Loader.hs \
545         src/Ganeti/HTools/Node.hs \
546         src/Ganeti/HTools/PeerMap.hs \
547         src/Ganeti/HTools/Program/Hail.hs \
548         src/Ganeti/HTools/Program/Harep.hs \
549         src/Ganeti/HTools/Program/Hbal.hs \
550         src/Ganeti/HTools/Program/Hcheck.hs \
551         src/Ganeti/HTools/Program/Hinfo.hs \
552         src/Ganeti/HTools/Program/Hscan.hs \
553         src/Ganeti/HTools/Program/Hspace.hs \
554         src/Ganeti/HTools/Program/Hroller.hs \
555         src/Ganeti/HTools/Program/Main.hs \
556         src/Ganeti/HTools/Types.hs \
557         src/Ganeti/Hypervisor/Xen/XmParser.hs \
558         src/Ganeti/Hypervisor/Xen/Types.hs \
559         src/Ganeti/Hash.hs \
560         src/Ganeti/JQueue.hs \
561         src/Ganeti/JSON.hs \
562         src/Ganeti/Jobs.hs \
563         src/Ganeti/Logging.hs \
564         src/Ganeti/Luxi.hs \
565         src/Ganeti/Monitoring/Server.hs \
566         src/Ganeti/Network.hs \
567         src/Ganeti/Objects.hs \
568         src/Ganeti/OpCodes.hs \
569         src/Ganeti/OpParams.hs \
570         src/Ganeti/Path.hs \
571         src/Ganeti/Query/Common.hs \
572         src/Ganeti/Query/Export.hs \
573         src/Ganeti/Query/Filter.hs \
574         src/Ganeti/Query/Group.hs \
575         src/Ganeti/Query/Job.hs \
576         src/Ganeti/Query/Language.hs \
577         src/Ganeti/Query/Network.hs \
578         src/Ganeti/Query/Node.hs \
579         src/Ganeti/Query/Query.hs \
580         src/Ganeti/Query/Server.hs \
581         src/Ganeti/Query/Types.hs \
582         src/Ganeti/Rpc.hs \
583         src/Ganeti/Runtime.hs \
584         src/Ganeti/Ssconf.hs \
585         src/Ganeti/THH.hs \
586         src/Ganeti/Types.hs \
587         src/Ganeti/Utils.hs
588
589 HS_TEST_SRCS = \
590         test/hs/Test/Ganeti/Attoparsec.hs \
591         test/hs/Test/Ganeti/BasicTypes.hs \
592         test/hs/Test/Ganeti/Block/Drbd/Parser.hs \
593         test/hs/Test/Ganeti/Block/Drbd/Types.hs \
594         test/hs/Test/Ganeti/Common.hs \
595         test/hs/Test/Ganeti/Confd/Types.hs \
596         test/hs/Test/Ganeti/Confd/Utils.hs \
597         test/hs/Test/Ganeti/Daemon.hs \
598         test/hs/Test/Ganeti/Errors.hs \
599         test/hs/Test/Ganeti/HTools/Backend/Simu.hs \
600         test/hs/Test/Ganeti/HTools/Backend/Text.hs \
601         test/hs/Test/Ganeti/HTools/CLI.hs \
602         test/hs/Test/Ganeti/HTools/Cluster.hs \
603         test/hs/Test/Ganeti/HTools/Container.hs \
604         test/hs/Test/Ganeti/HTools/Graph.hs \
605         test/hs/Test/Ganeti/HTools/Instance.hs \
606         test/hs/Test/Ganeti/HTools/Loader.hs \
607         test/hs/Test/Ganeti/HTools/Node.hs \
608         test/hs/Test/Ganeti/HTools/PeerMap.hs \
609         test/hs/Test/Ganeti/HTools/Types.hs \
610         test/hs/Test/Ganeti/Hypervisor/Xen/XmParser.hs \
611         test/hs/Test/Ganeti/JSON.hs \
612         test/hs/Test/Ganeti/Jobs.hs \
613         test/hs/Test/Ganeti/JQueue.hs \
614         test/hs/Test/Ganeti/Luxi.hs \
615         test/hs/Test/Ganeti/Network.hs \
616         test/hs/Test/Ganeti/Objects.hs \
617         test/hs/Test/Ganeti/OpCodes.hs \
618         test/hs/Test/Ganeti/Query/Filter.hs \
619         test/hs/Test/Ganeti/Query/Language.hs \
620         test/hs/Test/Ganeti/Query/Network.hs \
621         test/hs/Test/Ganeti/Query/Query.hs \
622         test/hs/Test/Ganeti/Rpc.hs \
623         test/hs/Test/Ganeti/Runtime.hs \
624         test/hs/Test/Ganeti/Ssconf.hs \
625         test/hs/Test/Ganeti/THH.hs \
626         test/hs/Test/Ganeti/TestCommon.hs \
627         test/hs/Test/Ganeti/TestHTools.hs \
628         test/hs/Test/Ganeti/TestHelper.hs \
629         test/hs/Test/Ganeti/Types.hs \
630         test/hs/Test/Ganeti/Utils.hs
631
632 HS_LIBTEST_SRCS = $(HS_LIB_SRCS) $(HS_TEST_SRCS)
633
634 HS_BUILT_SRCS = \
635         test/hs/Test/Ganeti/TestImports.hs \
636         src/Ganeti/Constants.hs \
637         src/Ganeti/Curl/Internal.hs \
638         src/Ganeti/Version.hs
639 HS_BUILT_SRCS_IN = \
640         $(patsubst %,%.in,$(filter-out src/Ganeti/Curl/Internal.hs,$(HS_BUILT_SRCS))) \
641         src/Ganeti/Curl/Internal.hsc
642
643 HS_LIBTESTBUILT_SRCS = $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS)
644
645 $(RUN_IN_TEMPDIR): | stamp-directories
646
647 doc/html/index.html: ENABLE_MANPAGES =
648 doc/man-html/index.html: ENABLE_MANPAGES = 1
649 doc/man-html/index.html: doc/manpages-enabled.rst $(mandocrst)
650
651 # Note: we use here an order-only prerequisite, as the contents of
652 # _autoconf.py are not actually influencing the html build output: it
653 # has to exist in order for the sphinx module to be loaded
654 # successfully, but we certainly don't want the docs to be rebuilt if
655 # it changes
656 doc/html/index.html doc/man-html/index.html: $(docinput) doc/conf.py \
657         configure.ac $(RUN_IN_TEMPDIR) lib/build/sphinx_ext.py \
658         lib/build/shell_example_lexer.py lib/opcodes.py lib/ht.py \
659         doc/css/style.css lib/rapi/connector.py lib/rapi/rlib2.py \
660         | $(BUILT_PYTHON_SOURCES)
661         @test -n "$(SPHINX)" || \
662             { echo 'sphinx-build' not found during configure; exit 1; }
663 if !MANPAGES_IN_DOC
664         if test -n '$(ENABLE_MANPAGES)'; then \
665           echo 'Man pages in documentation were disabled at configure time' >&2; \
666           exit 1; \
667         fi
668 endif
669 ## Sphinx provides little control over what content should be included. Some
670 ## mechanisms exist, but they all have drawbacks or actual issues. Since we
671 ## build two different versions of the documentation--once without man pages and
672 ## once, if enabled, with them--some control is necessary. xmpp-wrapper provides
673 ## us with this, but requires running in a temporary directory. It moves the
674 ## correct files into place depending on environment variables.
675         dir=$(dir $@) && \
676         @mkdir_p@ $$dir && \
677         PYTHONPATH=. ENABLE_MANPAGES=$(ENABLE_MANPAGES) COPY_DOC=1 \
678         $(RUN_IN_TEMPDIR) autotools/sphinx-wrapper $(SPHINX) -q -W -b html \
679             -d . \
680             -D version="$(VERSION_MAJOR).$(VERSION_MINOR)" \
681             -D release="$(PACKAGE_VERSION)" \
682             -D graphviz_dot="$(DOT)" \
683             -D enable_manpages="$(ENABLE_MANPAGES)" \
684             doc $(CURDIR)/$$dir && \
685         rm -f $$dir/.buildinfo $$dir/objects.inv
686         touch $@
687
688 doc/html: doc/html/index.html
689
690 doc/man-html: doc/man-html/index.html
691
692 doc/install-quick.rst: INSTALL
693 doc/news.rst: NEWS
694 doc/upgrade.rst: UPGRADE
695
696 doc/install-quick.rst doc/news.rst doc/upgrade.rst:
697         set -e; \
698         { echo '.. This file is automatically updated at build time from $<.'; \
699           echo '.. Do not edit.'; \
700           echo; \
701           cat $<; \
702         } > $@
703
704 doc/manpages-enabled.rst: Makefile | $(built_base_sources)
705         { echo '.. This file is automatically generated, do not edit!'; \
706           echo ''; \
707           echo 'Man pages'; \
708           echo '========='; \
709           echo; \
710           echo '.. toctree::'; \
711           echo '   :maxdepth: 1'; \
712           echo; \
713           for i in $(notdir $(mandocrst)); do \
714             echo "   $$i"; \
715           done | LC_ALL=C sort; \
716         } > $@
717
718 doc/man-%.rst: man/%.gen Makefile $(REPLACE_VARS_SED) | $(built_base_sources)
719 if MANPAGES_IN_DOC
720         { echo '.. This file is automatically updated at build time from $<.'; \
721           echo '.. Do not edit.'; \
722           echo; \
723           echo "$*"; \
724           echo '=========================================='; \
725           tail -n +3 $< | sed -f $(REPLACE_VARS_SED); \
726         } > $@
727 else
728         echo 'Man pages in documentation were disabled at configure time' >&2; \
729         exit 1;
730 endif
731
732 # Things to build but not to install (add it to EXTRA_DIST if it should be
733 # distributed)
734 noinst_DATA = \
735         doc/html \
736         $(BUILT_EXAMPLES) \
737         doc/examples/bash_completion \
738         doc/examples/bash_completion-debug \
739         $(manhtml)
740
741 if MANPAGES_IN_DOC
742 noinst_DATA += doc/man-html
743 endif
744
745 gnt_scripts = \
746         scripts/gnt-backup \
747         scripts/gnt-cluster \
748         scripts/gnt-debug \
749         scripts/gnt-group \
750         scripts/gnt-instance \
751         scripts/gnt-job \
752         scripts/gnt-network \
753         scripts/gnt-node \
754         scripts/gnt-os \
755         scripts/gnt-storage
756
757 PYTHON_BOOTSTRAP_SBIN = \
758         daemons/ganeti-masterd \
759         daemons/ganeti-noded \
760         daemons/ganeti-rapi \
761         daemons/ganeti-watcher \
762         $(gnt_scripts)
763
764 PYTHON_BOOTSTRAP = \
765         $(PYTHON_BOOTSTRAP_SBIN) \
766         tools/burnin \
767         tools/ensure-dirs \
768         tools/node-cleanup \
769         tools/node-daemon-setup \
770         tools/prepare-node-join
771
772 qa_scripts = \
773         qa/__init__.py \
774         qa/ganeti-qa.py \
775         qa/qa_cluster.py \
776         qa/qa_config.py \
777         qa/qa_daemon.py \
778         qa/qa_env.py \
779         qa/qa_error.py \
780         qa/qa_group.py \
781         qa/qa_instance.py \
782         qa/qa_job.py \
783         qa/qa_node.py \
784         qa/qa_os.py \
785         qa/qa_rapi.py \
786         qa/qa_tags.py \
787         qa/qa_utils.py
788
789 bin_SCRIPTS =
790 if WANT_HTOOLS
791 bin_SCRIPTS += $(HS_BIN_PROGS)
792 install-exec-hook:
793         @mkdir_p@ $(DESTDIR)$(iallocatorsdir)
794 # FIXME: this is a hardcoded logic, instead of auto-resolving
795         $(LN_S) -f ../../../bin/htools \
796           $(DESTDIR)$(iallocatorsdir)/hail
797         for role in $(HS_BIN_ROLES); do \
798           $(LN_S) -f htools $(DESTDIR)$(bindir)/$$role ; \
799         done
800 endif
801
802 $(HS_ALL_PROGS): %: %.hs $(HS_LIBTESTBUILT_SRCS) Makefile
803         @if [ "$(notdir $@)" = "test" ] && [ "$(HS_NODEV)" ]; then \
804           echo "Error: cannot run unittests without the development" \
805                " libraries (see devnotes.rst)" 1>&2; \
806           exit 1; \
807         fi
808         @rm -f $(notdir $@).tix
809         $(GHC) --make \
810           $(HFLAGS) \
811           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
812           -osuf $(notdir $@).o -hisuf $(notdir $@).hi \
813           $(HEXTRA) $(HEXTRA_INT) $@
814         @touch "$@"
815
816 # for the test/hs/htest binary, we need to enable profiling/coverage
817 test/hs/htest: HEXTRA_INT=-fhpc -itest/hs
818
819 # we compile the hpc-htools binary with the program coverage
820 test/hs/hpc-htools: HEXTRA_INT=-fhpc
821
822 # we compile the hpc-mon-collector binary with the program coverage
823 test/hs/hpc-mon-collector: HEXTRA_INT=-fhpc
824
825 # test dependency
826 test/hs/offline-tests.sh: test/hs/hpc-htools test/hs/hpc-mon-collector
827
828 # rules for building profiling-enabled versions of the haskell
829 # programs: hs-prof does the full two-step build, whereas
830 # hs-prof-quick does only the final rebuild (hs-prof must have been
831 # run before)
832 .PHONY: hs-prof hs-prof-quick
833 hs-prof:
834         @if [ -z "$(TARGET)" ]; then \
835           echo "You need to define TARGET when running this rule" 1>&2; \
836           exit 1; \
837         fi
838         $(MAKE) $(AM_MAKEFLAGS) clean
839         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf o"
840         rm -f $(HS_ALL_PROGS)
841         $(MAKE) $(AM_MAKEFLAGS) hs-prof-quick
842
843 hs-prof-quick:
844         @if [ -z "$(TARGET)" ]; then \
845           echo "You need to define TARGET when running this rule" 1>&2; \
846           exit 1; \
847         fi
848         $(MAKE) $(AM_MAKEFLAGS) $(TARGET) HEXTRA="-osuf prof_o -prof -auto-all"
849
850 dist_sbin_SCRIPTS = \
851         tools/ganeti-listrunner
852
853 nodist_sbin_SCRIPTS = \
854         $(PYTHON_BOOTSTRAP_SBIN) \
855         daemons/ganeti-cleaner
856
857 if ENABLE_CONFD
858 src/ganeti-confd: src/hconfd
859         cp -f $< $@
860
861 nodist_sbin_SCRIPTS += src/ganeti-confd
862 endif
863
864 if ENABLE_MOND
865 nodist_sbin_SCRIPTS += src/ganeti-mond
866 endif
867
868 python_scripts = \
869         tools/cfgshell \
870         tools/cfgupgrade \
871         tools/cfgupgrade12 \
872         tools/cluster-merge \
873         tools/confd-client \
874         tools/fmtjson \
875         tools/lvmstrap \
876         tools/move-instance \
877         tools/ovfconverter \
878         tools/sanitize-config
879
880 dist_tools_SCRIPTS = \
881         $(python_scripts) \
882         tools/burnin \
883         tools/kvm-console-wrapper \
884         tools/master-ip-setup \
885         tools/xen-console-wrapper
886
887 nodist_tools_python_scripts = \
888         tools/node-cleanup
889
890 nodist_tools_SCRIPTS = \
891         $(nodist_tools_python_scripts) \
892         tools/users-setup \
893         tools/vcluster-setup
894
895 pkglib_python_scripts = \
896         daemons/import-export \
897         tools/check-cert-expired
898
899 nodist_pkglib_python_scripts = \
900         tools/ensure-dirs \
901         tools/node-daemon-setup \
902         tools/prepare-node-join
903
904 myexeclib_SCRIPTS = \
905         daemons/daemon-util \
906         tools/kvm-ifup \
907         $(pkglib_python_scripts) \
908         $(HS_MYEXECLIB_PROGS)
909
910 nodist_myexeclib_SCRIPTS = \
911         $(nodist_pkglib_python_scripts)
912
913 EXTRA_DIST = \
914         NEWS \
915         UPGRADE \
916         epydoc.conf.in \
917         pylintrc \
918         autotools/build-bash-completion \
919         autotools/build-rpc \
920         autotools/check-header \
921         autotools/check-imports \
922         autotools/check-man-dashes \
923         autotools/check-man-references \
924         autotools/check-man-warnings \
925         autotools/check-news \
926         autotools/check-python-code \
927         autotools/check-tar \
928         autotools/check-version \
929         autotools/convert-constants \
930         autotools/docpp \
931         autotools/gen-py-coverage \
932         autotools/sphinx-wrapper \
933         autotools/testrunner \
934         autotools/wrong-hardcoded-paths \
935         $(RUN_IN_TEMPDIR) \
936         daemons/daemon-util.in \
937         daemons/ganeti-cleaner.in \
938         $(pkglib_python_scripts) \
939         devel/upload \
940         devel/webserver \
941         tools/kvm-ifup.in \
942         tools/users-setup.in \
943         tools/vcluster-setup.in \
944         $(docinput) \
945         doc/html \
946         $(BUILT_EXAMPLES:%=%.in) \
947         doc/examples/ganeti.default \
948         doc/examples/ganeti.default-debug \
949         doc/examples/hooks/ethers \
950         doc/examples/gnt-debug/README \
951         doc/examples/gnt-debug/delay0.json \
952         doc/examples/gnt-debug/delay50.json \
953         test/py/lockperf.py \
954         test/py/testutils.py \
955         test/py/mocks.py \
956         $(dist_TESTS) \
957         $(TEST_FILES) \
958         man/footer.rst \
959         $(manrst) \
960         $(maninput) \
961         qa/qa-sample.json \
962         $(qa_scripts) \
963         $(HS_LIBTEST_SRCS) $(HS_BUILT_SRCS_IN) \
964         $(HS_PROG_SRCS) \
965         src/lint-hints.hs \
966         test/hs/cli-tests-defs.sh \
967         test/hs/offline-test.sh \
968         .ghci
969
970 man_MANS = \
971         man/ganeti-cleaner.8 \
972         man/ganeti-confd.8 \
973         man/ganeti-listrunner.8 \
974         man/ganeti-masterd.8 \
975         man/ganeti-mond.8 \
976         man/ganeti-noded.8 \
977         man/ganeti-os-interface.7 \
978         man/ganeti-extstorage-interface.7 \
979         man/ganeti-rapi.8 \
980         man/ganeti-watcher.8 \
981         man/ganeti.7 \
982         man/gnt-backup.8 \
983         man/gnt-cluster.8 \
984         man/gnt-debug.8 \
985         man/gnt-group.8 \
986         man/gnt-network.8 \
987         man/gnt-instance.8 \
988         man/gnt-job.8 \
989         man/gnt-node.8 \
990         man/gnt-os.8 \
991         man/gnt-storage.8 \
992         man/hail.1 \
993         man/hbal.1 \
994         man/hcheck.1 \
995         man/hinfo.1 \
996         man/hscan.1 \
997         man/hspace.1 \
998         man/hroller.1 \
999         man/htools.1 \
1000         man/mon-collector.7
1001
1002 # Remove extensions from all filenames in man_MANS
1003 mannoext = $(patsubst %.1,%,$(patsubst %.7,%,$(patsubst %.8,%,$(man_MANS))))
1004
1005 manrst = $(patsubst %,%.rst,$(mannoext))
1006 manhtml = $(patsubst %.rst,%.html,$(manrst))
1007 mangen = $(patsubst %.rst,%.gen,$(manrst))
1008 maninput = \
1009         $(patsubst %.1,%.1.in,$(patsubst %.7,%.7.in,$(patsubst %.8,%.8.in,$(man_MANS)))) \
1010         $(patsubst %.html,%.html.in,$(manhtml)) \
1011         $(mangen)
1012
1013 TEST_FILES = \
1014         test/data/htools/clean-nonzero-score.data \
1015         test/data/htools/common-suffix.data \
1016         test/data/htools/empty-cluster.data \
1017         test/data/htools/hail-alloc-drbd.json \
1018         test/data/htools/hail-alloc-invalid-twodisks.json \
1019         test/data/htools/hail-alloc-twodisks.json \
1020         test/data/htools/hail-change-group.json \
1021         test/data/htools/hail-invalid-reloc.json \
1022         test/data/htools/hail-node-evac.json \
1023         test/data/htools/hail-reloc-drbd.json \
1024         test/data/htools/hbal-excl-tags.data \
1025         test/data/htools/hbal-split-insts.data \
1026         test/data/htools/hspace-tiered-dualspec.data \
1027         test/data/htools/hspace-tiered.data \
1028         test/data/htools/invalid-node.data \
1029         test/data/htools/missing-resources.data \
1030         test/data/htools/multiple-master.data \
1031         test/data/htools/n1-failure.data \
1032         test/data/htools/rapi/groups.json \
1033         test/data/htools/rapi/info.json \
1034         test/data/htools/rapi/instances.json \
1035         test/data/htools/rapi/nodes.json \
1036         test/data/htools/unique-reboot-order.data \
1037         test/hs/shelltests/htools-balancing.test \
1038         test/hs/shelltests/htools-basic.test \
1039         test/hs/shelltests/htools-dynutil.test \
1040         test/hs/shelltests/htools-excl.test \
1041         test/hs/shelltests/htools-hail.test \
1042         test/hs/shelltests/htools-hroller.test \
1043         test/hs/shelltests/htools-hspace.test \
1044         test/hs/shelltests/htools-invalid.test \
1045         test/hs/shelltests/htools-multi-group.test \
1046         test/hs/shelltests/htools-no-backend.test \
1047         test/hs/shelltests/htools-rapi.test \
1048         test/hs/shelltests/htools-single-group.test \
1049         test/hs/shelltests/htools-text-backend.test \
1050         test/hs/shelltests/htools-mon-collector.test \
1051         test/data/bdev-drbd-8.0.txt \
1052         test/data/bdev-drbd-8.3.txt \
1053         test/data/bdev-drbd-disk.txt \
1054         test/data/bdev-drbd-net-ip4.txt \
1055         test/data/bdev-drbd-net-ip6.txt \
1056         test/data/bdev-rbd/json_output_empty.txt \
1057         test/data/bdev-rbd/json_output_extra_matches.txt \
1058         test/data/bdev-rbd/json_output_no_matches.txt \
1059         test/data/bdev-rbd/json_output_ok.txt \
1060         test/data/bdev-rbd/plain_output_new_extra_matches.txt \
1061         test/data/bdev-rbd/plain_output_new_no_matches.txt \
1062         test/data/bdev-rbd/plain_output_new_ok.txt \
1063         test/data/bdev-rbd/plain_output_old_empty.txt \
1064         test/data/bdev-rbd/plain_output_old_extra_matches.txt \
1065         test/data/bdev-rbd/plain_output_old_no_matches.txt \
1066         test/data/bdev-rbd/plain_output_old_ok.txt \
1067         test/data/bdev-rbd/output_invalid.txt \
1068         test/data/cert1.pem \
1069         test/data/cert2.pem \
1070         test/data/cluster_config_2.7.json \
1071         test/data/cluster_config_downgraded_2.7.json \
1072         test/data/instance-minor-pairing.txt \
1073         test/data/ip-addr-show-dummy0.txt \
1074         test/data/ip-addr-show-lo-ipv4.txt \
1075         test/data/ip-addr-show-lo-ipv6.txt \
1076         test/data/ip-addr-show-lo-oneline-ipv4.txt \
1077         test/data/ip-addr-show-lo-oneline-ipv6.txt \
1078         test/data/ip-addr-show-lo-oneline.txt \
1079         test/data/ip-addr-show-lo.txt \
1080         test/data/kvm_0.12.5_help.txt \
1081         test/data/kvm_0.15.90_help.txt \
1082         test/data/kvm_0.9.1_help.txt \
1083         test/data/kvm_0.9.1_help_boot_test.txt \
1084         test/data/kvm_1.0_help.txt \
1085         test/data/kvm_1.1.2_help.txt \
1086         test/data/ovfdata/compr_disk.vmdk.gz \
1087         test/data/ovfdata/config.ini \
1088         test/data/ovfdata/corrupted_resources.ovf \
1089         test/data/ovfdata/empty.ini \
1090         test/data/ovfdata/empty.ovf \
1091         test/data/ovfdata/ganeti.mf \
1092         test/data/ovfdata/ganeti.ovf \
1093         test/data/ovfdata/gzip_disk.ovf \
1094         test/data/ovfdata/new_disk.vmdk \
1095         test/data/ovfdata/no_disk.ini \
1096         test/data/ovfdata/no_disk_in_ref.ovf \
1097         test/data/ovfdata/no_os.ini \
1098         test/data/ovfdata/no_ovf.ova \
1099         test/data/ovfdata/other/rawdisk.raw \
1100         test/data/ovfdata/ova.ova \
1101         test/data/ovfdata/rawdisk.raw \
1102         test/data/ovfdata/second_disk.vmdk \
1103         test/data/ovfdata/unsafe_path.ini \
1104         test/data/ovfdata/virtualbox.ovf \
1105         test/data/ovfdata/wrong_config.ini \
1106         test/data/ovfdata/wrong_extension.ovd \
1107         test/data/ovfdata/wrong_manifest.mf \
1108         test/data/ovfdata/wrong_manifest.ovf \
1109         test/data/ovfdata/wrong_ova.ova \
1110         test/data/ovfdata/wrong_xml.ovf \
1111         test/data/proc_drbd8.txt \
1112         test/data/proc_drbd80-emptyline.txt \
1113         test/data/proc_drbd83.txt \
1114         test/data/proc_drbd83_sync.txt \
1115         test/data/proc_drbd83_sync_want.txt \
1116         test/data/proc_drbd83_sync_krnl2.6.39.txt \
1117         test/data/qa-minimal-nodes-instances-only.json \
1118         test/data/sys_drbd_usermode_helper.txt \
1119         test/data/vgreduce-removemissing-2.02.02.txt \
1120         test/data/vgreduce-removemissing-2.02.66-fail.txt \
1121         test/data/vgreduce-removemissing-2.02.66-ok.txt \
1122         test/data/vgs-missing-pvs-2.02.02.txt \
1123         test/data/vgs-missing-pvs-2.02.66.txt \
1124         test/data/xen-xm-info-4.0.1.txt \
1125         test/data/xen-xm-list-4.0.1-dom0-only.txt \
1126         test/data/xen-xm-list-4.0.1-four-instances.txt \
1127         test/data/xen-xm-list-long-4.0.1.txt \
1128         test/data/xen-xm-uptime-4.0.1.txt \
1129         test/py/ganeti-cli.test \
1130         test/py/gnt-cli.test \
1131         test/py/import-export_unittest-helper
1132
1133 python_tests = \
1134         doc/examples/rapi_testutils.py \
1135         test/py/cfgupgrade_unittest.py \
1136         test/py/docs_unittest.py \
1137         test/py/ganeti.asyncnotifier_unittest.py \
1138         test/py/ganeti.backend_unittest-runasroot.py \
1139         test/py/ganeti.backend_unittest.py \
1140         test/py/ganeti.bdev_unittest.py \
1141         test/py/ganeti.cli_unittest.py \
1142         test/py/ganeti.client.gnt_cluster_unittest.py \
1143         test/py/ganeti.client.gnt_instance_unittest.py \
1144         test/py/ganeti.client.gnt_job_unittest.py \
1145         test/py/ganeti.cmdlib_unittest.py \
1146         test/py/ganeti.compat_unittest.py \
1147         test/py/ganeti.confd.client_unittest.py \
1148         test/py/ganeti.config_unittest.py \
1149         test/py/ganeti.constants_unittest.py \
1150         test/py/ganeti.daemon_unittest.py \
1151         test/py/ganeti.errors_unittest.py \
1152         test/py/ganeti.hooks_unittest.py \
1153         test/py/ganeti.ht_unittest.py \
1154         test/py/ganeti.http_unittest.py \
1155         test/py/ganeti.hypervisor.hv_chroot_unittest.py \
1156         test/py/ganeti.hypervisor.hv_fake_unittest.py \
1157         test/py/ganeti.hypervisor.hv_kvm_unittest.py \
1158         test/py/ganeti.hypervisor.hv_lxc_unittest.py \
1159         test/py/ganeti.hypervisor.hv_xen_unittest.py \
1160         test/py/ganeti.hypervisor_unittest.py \
1161         test/py/ganeti.impexpd_unittest.py \
1162         test/py/ganeti.jqueue_unittest.py \
1163         test/py/ganeti.jstore_unittest.py \
1164         test/py/ganeti.locking_unittest.py \
1165         test/py/ganeti.luxi_unittest.py \
1166         test/py/ganeti.masterd.iallocator_unittest.py \
1167         test/py/ganeti.masterd.instance_unittest.py \
1168         test/py/ganeti.mcpu_unittest.py \
1169         test/py/ganeti.netutils_unittest.py \
1170         test/py/ganeti.objects_unittest.py \
1171         test/py/ganeti.opcodes_unittest.py \
1172         test/py/ganeti.outils_unittest.py \
1173         test/py/ganeti.ovf_unittest.py \
1174         test/py/ganeti.qlang_unittest.py \
1175         test/py/ganeti.query_unittest.py \
1176         test/py/ganeti.rapi.baserlib_unittest.py \
1177         test/py/ganeti.rapi.client_unittest.py \
1178         test/py/ganeti.rapi.resources_unittest.py \
1179         test/py/ganeti.rapi.rlib2_unittest.py \
1180         test/py/ganeti.rapi.testutils_unittest.py \
1181         test/py/ganeti.rpc_unittest.py \
1182         test/py/ganeti.runtime_unittest.py \
1183         test/py/ganeti.serializer_unittest.py \
1184         test/py/ganeti.server.rapi_unittest.py \
1185         test/py/ganeti.ssconf_unittest.py \
1186         test/py/ganeti.ssh_unittest.py \
1187         test/py/ganeti.storage_unittest.py \
1188         test/py/ganeti.tools.burnin_unittest.py \
1189         test/py/ganeti.tools.ensure_dirs_unittest.py \
1190         test/py/ganeti.tools.node_daemon_setup_unittest.py \
1191         test/py/ganeti.tools.prepare_node_join_unittest.py \
1192         test/py/ganeti.uidpool_unittest.py \
1193         test/py/ganeti.utils.algo_unittest.py \
1194         test/py/ganeti.utils.filelock_unittest.py \
1195         test/py/ganeti.utils.hash_unittest.py \
1196         test/py/ganeti.utils.io_unittest-runasroot.py \
1197         test/py/ganeti.utils.io_unittest.py \
1198         test/py/ganeti.utils.log_unittest.py \
1199         test/py/ganeti.utils.lvm_unittest.py \
1200         test/py/ganeti.utils.mlock_unittest.py \
1201         test/py/ganeti.utils.nodesetup_unittest.py \
1202         test/py/ganeti.utils.process_unittest.py \
1203         test/py/ganeti.utils.retry_unittest.py \
1204         test/py/ganeti.utils.text_unittest.py \
1205         test/py/ganeti.utils.wrapper_unittest.py \
1206         test/py/ganeti.utils.x509_unittest.py \
1207         test/py/ganeti.utils_unittest.py \
1208         test/py/ganeti.vcluster_unittest.py \
1209         test/py/ganeti.workerpool_unittest.py \
1210         test/py/pycurl_reset_unittest.py \
1211         test/py/qa.qa_config_unittest.py \
1212         test/py/tempfile_fork_unittest.py
1213
1214 haskell_tests = test/hs/htest
1215
1216 dist_TESTS = \
1217         test/py/check-cert-expired_unittest.bash \
1218         test/py/daemon-util_unittest.bash \
1219         test/py/ganeti-cleaner_unittest.bash \
1220         test/py/import-export_unittest.bash \
1221         test/py/cli-test.bash \
1222         test/py/bash_completion.bash \
1223         $(python_tests)
1224
1225 nodist_TESTS =
1226 check_SCRIPTS =
1227
1228 if WANT_HSTESTS
1229 nodist_TESTS += $(haskell_tests)
1230 dist_TESTS += test/hs/offline-test.sh
1231 check_SCRIPTS += \
1232         test/hs/hpc-htools \
1233         test/hs/hpc-mon-collector \
1234         $(HS_BUILT_TEST_HELPERS)
1235 endif
1236
1237 TESTS = $(dist_TESTS) $(nodist_TESTS)
1238
1239 # Environment for all tests
1240 PLAIN_TESTS_ENVIRONMENT = \
1241         PYTHONPATH=. \
1242         TOP_SRCDIR=$(abs_top_srcdir) TOP_BUILDDIR=$(abs_top_builddir) \
1243         PYTHON=$(PYTHON) FAKEROOT=$(FAKEROOT_PATH) \
1244         $(RUN_IN_TEMPDIR)
1245
1246 # Environment for tests run by automake
1247 TESTS_ENVIRONMENT = \
1248         $(PLAIN_TESTS_ENVIRONMENT) $(abs_top_srcdir)/autotools/testrunner
1249
1250 all_python_code = \
1251         $(dist_sbin_SCRIPTS) \
1252         $(python_scripts) \
1253         $(pkglib_python_scripts) \
1254         $(nodist_pkglib_python_scripts) \
1255         $(nodist_tools_python_scripts) \
1256         $(python_tests) \
1257         $(pkgpython_PYTHON) \
1258         $(client_PYTHON) \
1259         $(cmdlib_PYTHON) \
1260         $(hypervisor_PYTHON) \
1261         $(rapi_PYTHON) \
1262         $(server_PYTHON) \
1263         $(pytools_PYTHON) \
1264         $(http_PYTHON) \
1265         $(confd_PYTHON) \
1266         $(masterd_PYTHON) \
1267         $(impexpd_PYTHON) \
1268         $(utils_PYTHON) \
1269         $(watcher_PYTHON) \
1270         $(noinst_PYTHON) \
1271         $(qa_scripts)
1272
1273 srclink_files = \
1274         man/footer.rst \
1275         test/py/check-cert-expired_unittest.bash \
1276         test/py/daemon-util_unittest.bash \
1277         test/py/ganeti-cleaner_unittest.bash \
1278         test/py/import-export_unittest.bash \
1279         test/py/cli-test.bash \
1280         test/py/bash_completion.bash \
1281         test/hs/offline-test.sh \
1282         test/hs/cli-tests-defs.sh \
1283         $(all_python_code) \
1284         $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS) \
1285         $(docinput)
1286
1287 check_python_code = \
1288         $(BUILD_BASH_COMPLETION) \
1289         $(CHECK_IMPORTS) \
1290         $(CHECK_HEADER) \
1291         $(DOCPP) \
1292         $(all_python_code)
1293
1294 lint_python_code = \
1295         ganeti \
1296         ganeti/http/server.py \
1297         $(dist_sbin_SCRIPTS) \
1298         $(python_scripts) \
1299         $(pkglib_python_scripts) \
1300         $(BUILD_BASH_COMPLETION) \
1301         $(CHECK_IMPORTS) \
1302         $(CHECK_HEADER) \
1303         $(DOCPP) \
1304         $(PYTHON_BOOTSTRAP)
1305
1306 standalone_python_modules = \
1307         lib/rapi/client.py \
1308         tools/ganeti-listrunner
1309
1310 pep8_python_code = \
1311         ganeti \
1312         ganeti/http/server.py \
1313         $(dist_sbin_SCRIPTS) \
1314         $(python_scripts) \
1315         $(pkglib_python_scripts) \
1316         $(BUILD_BASH_COMPLETION) \
1317         $(CHECK_HEADER) \
1318         $(DOCPP) \
1319         $(PYTHON_BOOTSTRAP) \
1320         qa
1321
1322 test/py/daemon-util_unittest.bash: daemons/daemon-util
1323
1324 test/py/ganeti-cleaner_unittest.bash: daemons/ganeti-cleaner
1325
1326 test/py/bash_completion.bash: doc/examples/bash_completion-debug
1327
1328 tools/kvm-ifup: tools/kvm-ifup.in $(REPLACE_VARS_SED)
1329         sed -f $(REPLACE_VARS_SED) < $< > $@
1330         chmod +x $@
1331
1332 tools/users-setup: tools/users-setup.in $(REPLACE_VARS_SED)
1333         sed -f $(REPLACE_VARS_SED) < $< > $@
1334         chmod +x $@
1335
1336 tools/vcluster-setup: tools/vcluster-setup.in $(REPLACE_VARS_SED)
1337         sed -f $(REPLACE_VARS_SED) < $< > $@
1338         chmod +x $@
1339
1340 daemons/%:: daemons/%.in $(REPLACE_VARS_SED)
1341         sed -f $(REPLACE_VARS_SED) < $< > $@
1342         chmod +x $@
1343
1344 doc/examples/%:: doc/examples/%.in $(REPLACE_VARS_SED)
1345         sed -f $(REPLACE_VARS_SED) < $< > $@
1346
1347 doc/examples/bash_completion: BC_ARGS = --compact
1348 doc/examples/bash_completion-debug: BC_ARGS =
1349
1350 doc/examples/bash_completion doc/examples/bash_completion-debug: \
1351         $(BUILD_BASH_COMPLETION) $(RUN_IN_TEMPDIR) \
1352         lib/cli.py $(gnt_scripts) $(client_PYTHON) tools/burnin \
1353         daemons/ganeti-cleaner \
1354         $(GENERATED_FILES) $(HS_GENERATED_FILES)
1355         PYTHONPATH=. $(RUN_IN_TEMPDIR) \
1356           $(CURDIR)/$(BUILD_BASH_COMPLETION) $(BC_ARGS) > $@
1357
1358 man/%.gen: man/%.rst lib/query.py lib/build/sphinx_ext.py \
1359         lib/build/shell_example_lexer.py \
1360         | $(RUN_IN_TEMPDIR) $(BUILT_PYTHON_SOURCES)
1361         @echo "Checking $< for hardcoded paths..."
1362         @if grep -nEf autotools/wrong-hardcoded-paths $<; then \
1363           echo "Man page $< has hardcoded paths (see above)!" 1>&2 ; \
1364           exit 1; \
1365         fi
1366         set -e ; \
1367         trap 'echo auto-removing $@; rm $@' EXIT; \
1368         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(DOCPP) < $< > $@ ;\
1369         $(CHECK_MAN_REFERENCES) $@; \
1370         trap - EXIT
1371
1372 man/%.7.in man/%.8.in man/%.1.in: man/%.gen man/footer.rst
1373         @test -n "$(PANDOC)" || \
1374           { echo 'pandoc' not found during configure; exit 1; }
1375         set -o pipefail -e; \
1376         trap 'echo auto-removing $@; rm $@' EXIT; \
1377         $(PANDOC) -s -f rst -t man $< man/footer.rst | \
1378           sed -e 's/\\@/@/g' > $@; \
1379         if test -n "$(MAN_HAS_WARNINGS)"; then $(CHECK_MAN_WARNINGS) $@; fi; \
1380         $(CHECK_MAN_DASHES) $@; \
1381         trap - EXIT
1382
1383 man/%.html.in: man/%.gen man/footer.rst
1384         @test -n "$(PANDOC)" || \
1385           { echo 'pandoc' not found during configure; exit 1; }
1386         set -o pipefail ; \
1387         $(PANDOC) --toc -s -f rst -t html $< man/footer.rst | \
1388           sed -e 's/\\@/@/g' > $@
1389
1390 man/%: man/%.in  $(REPLACE_VARS_SED)
1391         sed -f $(REPLACE_VARS_SED) < $< > $@
1392
1393 epydoc.conf: epydoc.conf.in $(REPLACE_VARS_SED)
1394         sed -f $(REPLACE_VARS_SED) < $< > $@
1395
1396 vcs-version:
1397         if test -d .git; then \
1398           git describe > $@; \
1399         elif test ! -f $@ ; then \
1400           echo "Cannot auto-generate $@ file"; exit 1; \
1401         fi
1402
1403 .PHONY: clean-vcs-version
1404 clean-vcs-version:
1405         rm -f vcs-version
1406
1407 .PHONY: regen-vcs-version
1408 regen-vcs-version:
1409         @set -e; \
1410         cd $(srcdir); \
1411         if test -d .git; then \
1412           T=`mktemp` ; trap 'rm -f $$T' EXIT; \
1413           git describe > $$T; \
1414           if ! cmp --quiet $$T vcs-version; then \
1415             mv $$T vcs-version; \
1416           fi; \
1417         fi
1418
1419 src/Ganeti/Version.hs: src/Ganeti/Version.hs.in \
1420         vcs-version $(built_base_sources)
1421         set -e; \
1422         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1423         sed -e "s/%ver%/$$VCSVER/" < $< > $@
1424
1425 src/Ganeti/Constants.hs: src/Ganeti/Constants.hs.in \
1426         lib/constants.py lib/_autoconf.py lib/luxi.py lib/errors.py \
1427         lib/jstore.py $(RUN_IN_TEMPDIR) \
1428         $(CONVERT_CONSTANTS) $(built_base_sources) \
1429         | lib/_vcsversion.py
1430         set -e; \
1431         { cat $< ; \
1432           PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CONVERT_CONSTANTS); \
1433         } > $@
1434
1435 src/Ganeti/Curl/Internal.hs: src/Ganeti/Curl/Internal.hsc | stamp-directories
1436         hsc2hs -o $@ $<
1437
1438 test/hs/Test/Ganeti/TestImports.hs: test/hs/Test/Ganeti/TestImports.hs.in \
1439         $(built_base_sources)
1440         set -e; \
1441         { cat $< ; \
1442           echo ; \
1443           for name in $(filter-out Ganeti.THH,$(subst /,.,$(patsubst %.hs,%,$(patsubst src/%,%,$(HS_LIB_SRCS))))) ; do \
1444             echo "import $$name ()" ; \
1445           done ; \
1446         } > $@
1447
1448 lib/_autoconf.py: Makefile | stamp-directories
1449         set -e; \
1450         { echo '# This file is automatically generated, do not edit!'; \
1451           echo '#'; \
1452           echo ''; \
1453           echo '"""Build-time configuration for Ganeti.'; \
1454           echo '';\
1455           echo 'This file is autogenerated by the build process.'; \
1456           echo 'For any changes you need to re-run ./configure (and'; \
1457           echo 'not edit by hand).'; \
1458           echo ''; \
1459           echo '"""'; \
1460           echo ''; \
1461           echo '# pylint: disable=C0301,C0324'; \
1462           echo '# because this is autogenerated, we do not want'; \
1463           echo '# style warnings' ; \
1464           echo ''; \
1465           echo "PACKAGE_VERSION = '$(PACKAGE_VERSION)'"; \
1466           echo "VERSION_MAJOR = '$(VERSION_MAJOR)'"; \
1467           echo "VERSION_MINOR = '$(VERSION_MINOR)'"; \
1468           echo "VERSION_REVISION = '$(VERSION_REVISION)'"; \
1469           echo "VERSION_SUFFIX = '$(VERSION_SUFFIX)'"; \
1470           echo "VERSION_FULL = '$(VERSION_FULL)'"; \
1471           echo "LOCALSTATEDIR = '$(localstatedir)'"; \
1472           echo "SYSCONFDIR = '$(sysconfdir)'"; \
1473           echo "SSH_CONFIG_DIR = '$(SSH_CONFIG_DIR)'"; \
1474           echo "SSH_LOGIN_USER = '$(SSH_LOGIN_USER)'"; \
1475           echo "SSH_CONSOLE_USER = '$(SSH_CONSOLE_USER)'"; \
1476           echo "EXPORT_DIR = '$(EXPORT_DIR)'"; \
1477           echo "OS_SEARCH_PATH = [$(OS_SEARCH_PATH)]"; \
1478           echo "ES_SEARCH_PATH = [$(ES_SEARCH_PATH)]"; \
1479           echo "XEN_BOOTLOADER = '$(XEN_BOOTLOADER)'"; \
1480           echo "XEN_CONFIG_DIR = '$(XEN_CONFIG_DIR)'"; \
1481           echo "XEN_KERNEL = '$(XEN_KERNEL)'"; \
1482           echo "XEN_INITRD = '$(XEN_INITRD)'"; \
1483           echo "KVM_KERNEL = '$(KVM_KERNEL)'"; \
1484           echo "FILE_STORAGE_DIR = '$(FILE_STORAGE_DIR)'"; \
1485           echo "ENABLE_FILE_STORAGE = $(ENABLE_FILE_STORAGE)"; \
1486           echo "SHARED_FILE_STORAGE_DIR = '$(SHARED_FILE_STORAGE_DIR)'"; \
1487           echo "ENABLE_SHARED_FILE_STORAGE = $(ENABLE_SHARED_FILE_STORAGE)"; \
1488           echo "IALLOCATOR_SEARCH_PATH = [$(IALLOCATOR_SEARCH_PATH)]"; \
1489           echo "KVM_PATH = '$(KVM_PATH)'"; \
1490           echo "IP_PATH = '$(IP_PATH)'"; \
1491           echo "SOCAT_PATH = '$(SOCAT)'"; \
1492           echo "SOCAT_USE_ESCAPE = $(SOCAT_USE_ESCAPE)"; \
1493           echo "SOCAT_USE_COMPRESS = $(SOCAT_USE_COMPRESS)"; \
1494           echo "LVM_STRIPECOUNT = $(LVM_STRIPECOUNT)"; \
1495           echo "TOOLSDIR = '$(toolsdir)'"; \
1496           echo "GNT_SCRIPTS = [$(foreach i,$(notdir $(gnt_scripts)),'$(i)',)]"; \
1497           echo "HTOOLS_PROGS = [$(foreach i,$(HS_HTOOLS_PROGS),'$(i)',)]"; \
1498           echo "PKGLIBDIR = '$(pkglibdir)'"; \
1499           echo "DRBD_BARRIERS = '$(DRBD_BARRIERS)'"; \
1500           echo "DRBD_NO_META_FLUSH = $(DRBD_NO_META_FLUSH)"; \
1501           echo "SYSLOG_USAGE = '$(SYSLOG_USAGE)'"; \
1502           echo "DAEMONS_GROUP = '$(DAEMONS_GROUP)'"; \
1503           echo "ADMIN_GROUP = '$(ADMIN_GROUP)'"; \
1504           echo "MASTERD_USER = '$(MASTERD_USER)'"; \
1505           echo "MASTERD_GROUP = '$(MASTERD_GROUP)'"; \
1506           echo "RAPI_USER = '$(RAPI_USER)'"; \
1507           echo "RAPI_GROUP = '$(RAPI_GROUP)'"; \
1508           echo "CONFD_USER = '$(CONFD_USER)'"; \
1509           echo "CONFD_GROUP = '$(CONFD_GROUP)'"; \
1510           echo "NODED_USER = '$(NODED_USER)'"; \
1511           echo "NODED_GROUP = '$(NODED_GROUP)'"; \
1512           echo "MOND_USER = '$(MOND_USER)'"; \
1513           echo "MOND_GROUP = '$(MOND_GROUP)'"; \
1514           echo "DISK_SEPARATOR = '$(DISK_SEPARATOR)'"; \
1515           echo "QEMUIMG_PATH = '$(QEMUIMG_PATH)'"; \
1516           echo "HTOOLS = True"; \
1517           echo "ENABLE_CONFD = $(ENABLE_CONFD)"; \
1518           echo "XEN_CMD = '$(XEN_CMD)'"; \
1519           echo "ENABLE_SPLIT_QUERY = $(ENABLE_SPLIT_QUERY)"; \
1520           echo "ENABLE_RESTRICTED_COMMANDS = $(ENABLE_RESTRICTED_COMMANDS)"; \
1521           echo "ENABLE_MOND = $(ENABLE_MOND)"; \
1522 ## Write dictionary with man page name as the key and the section number as the
1523 ## value
1524           echo "MAN_PAGES = {"; \
1525           for i in $(notdir $(man_MANS)); do \
1526             echo "$$i" | sed -re 's/^(.*)\.([0-9]+)$$/  "\1": \2,/g'; \
1527           done; \
1528           echo "}"; \
1529         } > $@
1530
1531 lib/_vcsversion.py: Makefile vcs-version | stamp-directories
1532         set -e; \
1533         VCSVER=`cat $(abs_top_srcdir)/vcs-version`; \
1534         { echo '# This file is automatically generated, do not edit!'; \
1535           echo '#'; \
1536           echo ''; \
1537           echo '"""Build-time VCS version number for Ganeti.'; \
1538           echo '';\
1539           echo 'This file is autogenerated by the build process.'; \
1540           echo 'For any changes you need to re-run ./configure (and'; \
1541           echo 'not edit by hand).'; \
1542           echo ''; \
1543           echo '"""'; \
1544           echo ''; \
1545           echo '# pylint: disable=C0301,C0324'; \
1546           echo '# because this is autogenerated, we do not want'; \
1547           echo '# style warnings' ; \
1548           echo ''; \
1549           echo "VCS_VERSION = '$$VCSVER'"; \
1550         } > $@
1551
1552 lib/_generated_rpc.py: lib/rpc_defs.py $(BUILD_RPC)
1553         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(BUILD_RPC) lib/rpc_defs.py > $@
1554
1555 $(SHELL_ENV_INIT): Makefile stamp-directories
1556         set -e; \
1557         { echo '# Allow overriding for tests'; \
1558           echo 'readonly LOCALSTATEDIR=$${LOCALSTATEDIR:-$${GANETI_ROOTDIR:-}$(localstatedir)}'; \
1559           echo 'readonly SYSCONFDIR=$${SYSCONFDIR:-$${GANETI_ROOTDIR:-}$(sysconfdir)}'; \
1560           echo; \
1561           echo 'readonly PKGLIBDIR=$(pkglibdir)'; \
1562           echo 'readonly LOG_DIR="$$LOCALSTATEDIR/log/ganeti"'; \
1563           echo 'readonly RUN_DIR="$$LOCALSTATEDIR/run/ganeti"'; \
1564           echo 'readonly DATA_DIR="$$LOCALSTATEDIR/lib/ganeti"'; \
1565           echo 'readonly CONF_DIR="$$SYSCONFDIR/ganeti"'; \
1566         } > $@
1567
1568 ## Writes sed script to replace placeholders with build-time values. The
1569 ## additional quotes after the first @ sign are necessary to stop configure
1570 ## from replacing those values as well.
1571 $(REPLACE_VARS_SED): $(SHELL_ENV_INIT) Makefile stamp-directories
1572         set -e; \
1573         { echo 's#@''PREFIX@#$(prefix)#g'; \
1574           echo 's#@''SYSCONFDIR@#$(sysconfdir)#g'; \
1575           echo 's#@''LOCALSTATEDIR@#$(localstatedir)#g'; \
1576           echo 's#@''BINDIR@#$(bindir)#g'; \
1577           echo 's#@''SBINDIR@#$(sbindir)#g'; \
1578           echo 's#@''LIBDIR@#$(libdir)#g'; \
1579           echo 's#@''GANETI_VERSION@#$(PACKAGE_VERSION)#g'; \
1580           echo 's#@''CUSTOM_XEN_BOOTLOADER@#$(XEN_BOOTLOADER)#g'; \
1581           echo 's#@''CUSTOM_XEN_KERNEL@#$(XEN_KERNEL)#g'; \
1582           echo 's#@''CUSTOM_XEN_INITRD@#$(XEN_INITRD)#g'; \
1583           echo 's#@''CUSTOM_IALLOCATOR_SEARCH_PATH@#$(IALLOCATOR_SEARCH_PATH)#g'; \
1584           echo 's#@''CUSTOM_EXPORT_DIR@#$(EXPORT_DIR)#g'; \
1585           echo 's#@''RPL_FILE_STORAGE_DIR@#$(FILE_STORAGE_DIR)#g'; \
1586           echo 's#@''RPL_SSH_INITD_SCRIPT@#$(SSH_INITD_SCRIPT)#g'; \
1587           echo 's#@''PKGLIBDIR@#$(pkglibdir)#g'; \
1588           echo 's#@''GNTMASTERUSER@#$(MASTERD_USER)#g'; \
1589           echo 's#@''GNTRAPIUSER@#$(RAPI_USER)#g'; \
1590           echo 's#@''GNTCONFDUSER@#$(CONFD_USER)#g'; \
1591           echo 's#@''GNTNODEDUSER@#$(NODED_USER)#g'; \
1592           echo 's#@''GNTMONDUSER@#$(MOND_USER)#g'; \
1593           echo 's#@''GNTRAPIGROUP@#$(RAPI_GROUP)#g'; \
1594           echo 's#@''GNTADMINGROUP@#$(ADMIN_GROUP)#g'; \
1595           echo 's#@''GNTCONFDGROUP@#$(CONFD_GROUP)#g'; \
1596           echo 's#@''GNTMASTERDGROUP@#$(MASTERD_GROUP)#g'; \
1597           echo 's#@''GNTMONDGROUP@#$(MOND_GROUP)#g'; \
1598           echo 's#@''GNTDAEMONSGROUP@#$(DAEMONS_GROUP)#g'; \
1599           echo 's#@''CUSTOM_ENABLE_CONFD@#$(ENABLE_CONFD)#g'; \
1600           echo 's#@''CUSTOM_ENABLE_MOND@#$(ENABLE_MOND)#g'; \
1601           echo 's#@''MODULES@#$(strip $(lint_python_code))#g'; \
1602           echo 's#@''XEN_CONFIG_DIR@#$(XEN_CONFIG_DIR)#g'; \
1603           echo; \
1604           echo '/^@SHELL_ENV_INIT@$$/ {'; \
1605           echo '  r $(SHELL_ENV_INIT)'; \
1606           echo '  d'; \
1607           echo '}'; \
1608         } > $@
1609
1610 # Using deferred evaluation
1611 daemons/ganeti-%: MODULE = ganeti.server.$(patsubst ganeti-%,%,$(notdir $@))
1612 daemons/ganeti-watcher: MODULE = ganeti.watcher
1613 scripts/%: MODULE = ganeti.client.$(subst -,_,$(notdir $@))
1614 tools/burnin: MODULE = ganeti.tools.burnin
1615 tools/ensure-dirs: MODULE = ganeti.tools.ensure_dirs
1616 tools/node-daemon-setup: MODULE = ganeti.tools.node_daemon_setup
1617 tools/prepare-node-join: MODULE = ganeti.tools.prepare_node_join
1618 tools/node-cleanup: MODULE = ganeti.tools.node_cleanup
1619 $(HS_BUILT_TEST_HELPERS): TESTROLE = $(patsubst test/hs/%,%,$@)
1620
1621 $(PYTHON_BOOTSTRAP): Makefile | stamp-directories
1622         test -n "$(MODULE)" || { echo Missing module; exit 1; }
1623         set -e; \
1624         { echo '#!/usr/bin/python'; \
1625           echo '# This file is automatically generated, do not edit!'; \
1626           echo "# Edit $(MODULE) instead."; \
1627           echo; \
1628           echo '"""Bootstrap script for L{$(MODULE)}"""'; \
1629           echo; \
1630           echo '# pylint: disable=C0103'; \
1631           echo '# C0103: Invalid name'; \
1632           echo; \
1633           echo 'import sys'; \
1634           echo 'import $(MODULE) as main'; \
1635           echo; \
1636           echo '# Temporarily alias commands until bash completion'; \
1637           echo '# generator is changed'; \
1638           echo 'if hasattr(main, "commands"):'; \
1639           echo '  commands = main.commands # pylint: disable=E1101'; \
1640           echo 'if hasattr(main, "aliases"):'; \
1641           echo '  aliases = main.aliases # pylint: disable=E1101'; \
1642           echo; \
1643           echo 'if __name__ == "__main__":'; \
1644           echo '  sys.exit(main.Main())'; \
1645         } > $@
1646         chmod u+x $@
1647
1648 $(HS_BUILT_TEST_HELPERS): Makefile
1649         @test -n "$(TESTROLE)" || { echo Missing TESTROLE; exit 1; }
1650         set -e; \
1651         { echo '#!/bin/sh'; \
1652           echo '# This file is automatically generated, do not edit!'; \
1653           echo "# Edit Makefile.am instead."; \
1654           echo; \
1655           echo "HTOOLS=$(TESTROLE) exec ./test/hs/hpc-htools \"\$$@\""; \
1656         } > $@
1657         chmod u+x $@
1658
1659 stamp-directories: Makefile
1660         $(MAKE) $(AM_MAKEFLAGS) ganeti
1661         @mkdir_p@ $(DIRS) $(BUILDTIME_DIR_AUTOCREATE)
1662         touch $@
1663
1664 # We need to create symlinks because "make distcheck" will not install Python
1665 # files when building.
1666 stamp-srclinks: Makefile | stamp-directories
1667         set -e; \
1668         for i in $(srclink_files); do \
1669           if test ! -f $$i -a -f $(abs_top_srcdir)/$$i; then \
1670             $(LN_S) $(abs_top_srcdir)/$$i $$i; \
1671           fi; \
1672         done
1673         touch $@
1674
1675 .PHONY: ganeti
1676 ganeti:
1677         cd $(top_builddir) && test -h "$@" || { rm -f $@ && $(LN_S) lib $@; }
1678
1679 .PHONY: check-dirs
1680 check-dirs: $(GENERATED_FILES)
1681         @set -e; \
1682         find . -type d \( -name . -o -name .git -prune -o -print \) | { \
1683           error=; \
1684           while read dir; do \
1685             case "$$dir" in \
1686               $(strip $(patsubst %,(./%) ;;,$(DIRCHECK_EXCLUDE) $(DIRS))) \
1687               *) error=1; echo "Directory $$dir not listed in Makefile" >&2 ;; \
1688             esac; \
1689           done; \
1690           for dir in $(DIRS); do \
1691             if ! test -d "$$dir"; then \
1692               echo "Directory $$dir listed in DIRS does not exist" >&2; \
1693               error=1; \
1694             fi \
1695           done; \
1696           test -z "$$error"; \
1697         }
1698
1699 .PHONY: check-local
1700 check-local: check-dirs $(GENERATED_FILES)
1701         $(CHECK_PYTHON_CODE) $(check_python_code)
1702         PYTHONPATH=. $(CHECK_HEADER) $(check_python_code)
1703         $(CHECK_VERSION) $(VERSION) $(top_srcdir)/NEWS
1704         RELEASE=$(PACKAGE_VERSION) $(CHECK_NEWS) < $(top_srcdir)/NEWS
1705         PYTHONPATH=. $(RUN_IN_TEMPDIR) $(CURDIR)/$(CHECK_IMPORTS) . $(standalone_python_modules)
1706         @expver=$(VERSION_MAJOR).$(VERSION_MINOR); \
1707         error= ; \
1708         if test "`head -n 1 $(top_srcdir)/README`" != "Ganeti $$expver"; then \
1709           echo "Incorrect version in README, expected $$expver" >&2; \
1710           error=1; \
1711         fi; \
1712         for file in doc/iallocator.rst doc/hooks.rst doc/virtual-cluster.rst \
1713             doc/security.rst; do \
1714           if test "`sed -ne '4 p' $(top_srcdir)/$$file`" != \
1715             "Documents Ganeti version $$expver"; then \
1716             echo "Incorrect version in $$file, expected $$expver" >&2; \
1717             error=1; \
1718           fi; \
1719         done; \
1720         if ! test -f $(top_srcdir)/doc/design-$$expver.rst; then \
1721           echo "File $(top_srcdir)/doc/design-$$expver.rst not found" >&2; \
1722           error=1; \
1723         fi; \
1724         if test "`sed -ne '5 p' $(top_srcdir)/doc/design-draft.rst`" != \
1725           ".. Last updated for Ganeti $$expver"; then \
1726           echo "doc/design-draft.rst was not updated for version $$expver" >&2; \
1727           error=1; \
1728         fi; \
1729         for file in configure.ac $(HS_LIBTEST_SRCS) $(HS_PROG_SRCS); do \
1730           if test $$(wc --max-line-length < $(top_srcdir)/$$file) -gt 80; then \
1731             echo "Longest line in $$file is longer than 80 characters" >&2; \
1732             error=1; \
1733           fi; \
1734         done; \
1735         test -z "$$error"
1736
1737 .PHONY: hs-tests
1738 hs-tests: test/hs/htest | $(BUILT_PYTHON_SOURCES)
1739         @rm -f htest.tix
1740         ./test/hs/htest
1741
1742 .PHONY: hs-shell
1743 hs-shell: test/hs/hpc-htools test/hs/hpc-mon-collector $(HS_BUILT_TEST_HELPERS)
1744         @rm -f hpc-htools.tix hpc-mon-collector.tix
1745         HBINARY="./test/hs/hpc-htools" ./test/hs/offline-test.sh
1746
1747 .PHONY: hs-check
1748 hs-check: hs-tests hs-shell
1749
1750 # E111: indentation is not a multiple of four
1751 # E121: continuation line indentation is not a multiple of four
1752 #       (since our indent level is not 4)
1753 # E125: continuation line does not distinguish itself from next logical line
1754 #       (since our indent level is not 4)
1755 # E127: continuation line over-indented for visual indent
1756 #       (since our indent level is not 4)
1757 # note: do NOT add E128 here; it's a valid style error in most cases!
1758 # I've seen real errors, but also some cases were we indent wrongly
1759 # due to line length; try to rework the cases where it is triggered,
1760 # instead of silencing it
1761 # E261: at least two spaces before inline comment
1762 # E501: line too long (80 characters)
1763 PEP8_IGNORE = E111,E121,E125,E127,E261,E501
1764
1765 # For excluding pep8 expects filenames only, not whole paths
1766 PEP8_EXCLUDE = $(subst $(space),$(comma),$(strip $(notdir $(BUILT_PYTHON_SOURCES))))
1767
1768 LINT_TARGETS = pylint pylint-qa
1769 if HAS_PEP8
1770 LINT_TARGETS += pep8
1771 endif
1772 if HAS_HLINT
1773 LINT_TARGETS += hlint
1774 endif
1775
1776 .PHONY: lint
1777 lint: $(LINT_TARGETS)
1778
1779 .PHONY: pylint
1780 pylint: $(GENERATED_FILES)
1781         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1782         $(PYLINT) $(LINT_OPTS) $(lint_python_code)
1783
1784 .PHONY: pylint-qa
1785 pylint-qa: $(GENERATED_FILES)
1786         @test -n "$(PYLINT)" || { echo 'pylint' not found during configure; exit 1; }
1787         cd $(top_srcdir)/qa && \
1788           PYTHONPATH=$(abs_top_srcdir) $(PYLINT) $(LINT_OPTS) \
1789           --rcfile  ../pylintrc $(patsubst qa/%.py,%,$(qa_scripts))
1790
1791 .PHONY: pep8
1792 pep8: $(GENERATED_FILES)
1793         @test -n "$(PEP8)" || { echo 'pep8' not found during configure; exit 1; }
1794         $(PEP8) --ignore='$(PEP8_IGNORE)' --exclude='$(PEP8_EXCLUDE)' \
1795           --repeat $(pep8_python_code)
1796
1797 # FIXME: remove ignore "Use void" when GHC 6.x is deprecated
1798 HLINT_EXCLUDES = src/Ganeti/THH.hs test/hs/hpc-htools.hs
1799 .PHONY: hlint
1800 hlint: $(HS_BUILT_SRCS) src/lint-hints.hs
1801         @test -n "$(HLINT)" || { echo 'hlint' not found during configure; exit 1; }
1802         @rm -f doc/hs-lint.html
1803         if tty -s; then C="-c"; else C=""; fi; \
1804         $(HLINT) --utf8 --report=doc/hs-lint.html --cross $$C \
1805           --ignore "Use first" \
1806           --ignore "Use &&&" \
1807           --ignore "Use void" \
1808           --ignore "Reduce duplication" \
1809           --hint src/lint-hints \
1810           $(filter-out $(HLINT_EXCLUDES),$(HS_LIBTEST_SRCS) $(HS_PROG_SRCS))
1811         @if [ ! -f doc/hs-lint.html ]; then \
1812           echo "All good" > doc/hs-lint.html; \
1813         fi
1814
1815 # a dist hook rule for updating the vcs-version file; this is
1816 # hardcoded due to where it needs to build the file...
1817 dist-hook:
1818         $(MAKE) $(AM_MAKEFLAGS) regen-vcs-version
1819         rm -f $(top_distdir)/vcs-version
1820         cp -p $(srcdir)/vcs-version $(top_distdir)
1821
1822 # a distcheck hook rule for catching revision control directories
1823 distcheck-hook:
1824         if find $(top_distdir) -name .svn -or -name .git | grep .; then \
1825           echo "Found revision control files in final archive." 1>&2; \
1826           exit 1; \
1827         fi
1828         if find $(top_distdir) -name '*.py[co]' | grep .; then \
1829           echo "Found Python byte code in final archive." 1>&2; \
1830           exit 1; \
1831         fi
1832         if find $(top_distdir) -name '*~' | grep .; then \
1833           echo "Found backup files in final archive." 1>&2; \
1834           exit 1; \
1835         fi
1836 # Empty files or directories should not be distributed. They can cause
1837 # unnecessary warnings for packagers. Directories used by automake during
1838 # distcheck must be excluded.
1839         if find $(top_distdir) -empty -and -not \( \
1840             -path $(top_distdir)/_build -or \
1841             -path $(top_distdir)/_inst \) | grep .; then \
1842           echo "Found empty files or directories in final archive." 1>&2; \
1843           exit 1; \
1844         fi
1845         if test -e $(top_distdir)/doc/man-html; then \
1846           echo "Found documentation including man pages in final archive" >&2; \
1847           exit 1; \
1848         fi
1849
1850 # Backwards compatible distcheck-release target
1851 distcheck-release: distcheck
1852
1853 distrebuildcheck: dist
1854         set -e; \
1855         builddir=$$(mktemp -d $(abs_srcdir)/distrebuildcheck.XXXXXXX); \
1856         trap "echo Removing $$builddir; cd $(abs_srcdir); rm -rf $$builddir" EXIT; \
1857         cd $$builddir; \
1858         tar xzf $(abs_srcdir)/$(distdir).tar.gz; \
1859         cd $(distdir); \
1860         ./configure; \
1861         $(MAKE) maintainer-clean; \
1862         cp $(abs_srcdir)/vcs-version .; \
1863         ./configure; \
1864         $(MAKE) $(AM_MAKEFLAGS)
1865
1866 dist-release: dist
1867         set -e; \
1868         for i in $(DIST_ARCHIVES); do \
1869           echo -n "Checking $$i ... "; \
1870           autotools/check-tar < $$i; \
1871           echo OK; \
1872         done
1873
1874 install-exec-local:
1875         @mkdir_p@ "$(DESTDIR)${localstatedir}/lib/ganeti" \
1876           "$(DESTDIR)${localstatedir}/log/ganeti" \
1877           "$(DESTDIR)${localstatedir}/run/ganeti"
1878
1879 .PHONY: apidoc
1880 if WANT_HSAPIDOC
1881 apidoc: py-apidoc hs-apidoc
1882 else
1883 apidoc: py-apidoc
1884 endif
1885
1886 .PHONY: py-apidoc
1887 py-apidoc: epydoc.conf $(RUN_IN_TEMPDIR) $(GENERATED_FILES)
1888         env - PATH="$$PATH" PYTHONPATH="$$PYTHONPATH" \
1889         $(RUN_IN_TEMPDIR) epydoc -v \
1890           --conf $(CURDIR)/epydoc.conf \
1891           --output $(CURDIR)/$(APIDOC_PY_DIR)
1892
1893 .PHONY: hs-apidoc
1894 hs-apidoc: $(APIDOC_HS_DIR)/index.html
1895
1896 $(APIDOC_HS_DIR)/index.html: $(HS_LIBTESTBUILT_SRCS) Makefile
1897         @test -n "$(HSCOLOUR)" || \
1898             { echo 'HsColour' not found during configure; exit 1; }
1899         @test -n "$(HADDOCK)" || \
1900             { echo 'haddock' not found during configure; exit 1; }
1901         rm -rf $(APIDOC_HS_DIR)/*
1902         for i in $(ALL_APIDOC_HS_DIRS); do \
1903           @mkdir_p@ $$i; \
1904           $(HSCOLOUR) -print-css > $$i/hscolour.css; \
1905         done
1906         set -e ; \
1907         export LC_ALL=en_US.UTF-8; \
1908         OPTGHC="--optghc=-isrc --optghc=-itest/hs"; \
1909         if [ "$(HS_PARALLEL3)" ]; \
1910         then OPTGHC="$$OPTGHC --optghc=$(HS_PARALLEL3)"; \
1911         fi; \
1912         if [ "$(HS_REGEX_PCRE)" ]; \
1913         then OPTGHC="$$OPTGHC --optghc=$(HS_REGEX_PCRE)"; \
1914         fi; \
1915         for file in $(HS_LIBTESTBUILT_SRCS); do \
1916           f_nosrc=$${file##src/}; \
1917           f_notst=$${f_nosrc##test/hs/}; \
1918           f_html=$${f_notst%%.hs}.html; \
1919           $(HSCOLOUR) -css -anchor $$file > $(APIDOC_HS_DIR)/$$f_html ; \
1920         done ; \
1921         $(HADDOCK) --odir $(APIDOC_HS_DIR) --html --ignore-all-exports -w \
1922           -t ganeti -p src/haddock-prologue \
1923           --source-module="%{MODULE/.//}.html" \
1924           --source-entity="%{MODULE/.//}.html#%{NAME}" \
1925           $$OPTGHC \
1926           $(HS_LIBTESTBUILT_SRCS)
1927
1928 .PHONY: TAGS
1929 TAGS: $(GENERATED_FILES)
1930         rm -f TAGS
1931         $(GHC) -e ":etags" -v0 \
1932           $(filter-out -O -Werror,$(HFLAGS)) \
1933           $(HS_PARALLEL3) $(HS_REGEX_PCRE) \
1934           $(HS_LIBTEST_SRCS)
1935         find . -path './lib/*.py' -o -path './scripts/gnt-*' -o \
1936           -path './daemons/ganeti-*' -o -path './tools/*' -o \
1937           -path './qa/*.py' | \
1938           etags -l python -a -
1939
1940 .PHONY: coverage
1941 if WANT_HTOOLS
1942 coverage: py-coverage hs-coverage
1943 else
1944 coverage: py-coverage
1945 endif
1946
1947 .PHONY: py-coverage
1948 py-coverage: $(GENERATED_FILES) $(python_tests)
1949         @test -n "$(PYCOVERAGE)" || \
1950             { echo 'python-coverage' not found during configure; exit 1; }
1951         set -e; \
1952         COVERAGE=$(PYCOVERAGE) \
1953         COVERAGE_FILE=$(CURDIR)/$(COVERAGE_PY_DIR)/data \
1954         TEXT_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR)/report.txt \
1955         HTML_COVERAGE=$(CURDIR)/$(COVERAGE_PY_DIR) \
1956         $(PLAIN_TESTS_ENVIRONMENT) \
1957         $(abs_top_srcdir)/autotools/gen-py-coverage \
1958         $(python_tests)
1959
1960 .PHONY: hs-coverage
1961 hs-coverage: $(haskell_tests) test/hs/hpc-htools test/hs/hpc-mon-collector
1962         rm -f *.tix
1963         $(MAKE) $(AM_MAKEFLAGS) hs-check
1964         @mkdir_p@ $(COVERAGE_HS_DIR)
1965         hpc sum --union $(HPCEXCL) \
1966           htest.tix hpc-htools.tix hpc-mon-collector.tix > coverage-hs.tix
1967         hpc markup --destdir=$(COVERAGE_HS_DIR) coverage-hs.tix
1968         hpc report coverage-hs.tix
1969         $(LN_S) -f hpc_index.html $(COVERAGE_HS_DIR)/index.html
1970
1971 # Special "kind-of-QA" target for htools, needs special setup (all
1972 # tools compiled with -fhpc)
1973 .PHONY: live-test
1974 live-test: all
1975         set -e ; \
1976         cd src; \
1977         rm -f .hpc; $(LN_S) ../.hpc .hpc; \
1978         rm -f *.tix *.mix; \
1979         ./live-test.sh; \
1980         hpc sum --union $(HPCEXCL) $(addsuffix .tix,$(HS_PROGS:src/%=%)) \
1981           --output=live-test.tix ; \
1982         @mkdir_p@ ../$(COVERAGE_HS_DIR) ; \
1983         hpc markup --destdir=../$(COVERAGE_HS_DIR) live-test \
1984           --srcdir=.. $(HPCEXCL) ; \
1985         hpc report --srcdir=.. live-test $(HPCEXCL)
1986
1987 commit-check: distcheck lint apidoc
1988
1989 .PHONY: gitignore-check
1990 gitignore-check:
1991         @if [ -n "`git status --short`" ]; then \
1992           echo "Git status is not clean!" 1>&2 ; \
1993           git status --short; \
1994           exit 1; \
1995         fi
1996
1997 # target to rebuild all man pages (both groff and html output)
1998 .PHONY: man
1999 man: $(man_MANS) $(manhtml)
2000
2001 # Target that builds all binaries (including those that are not
2002 # rebuilt except when running the tests)
2003 .PHONY: really-all
2004 really-all: all $(check_SCRIPTS) $(haskell_tests) $(HS_ALL_PROGS)
2005
2006 # we don't need the ancient implicit rules:
2007 %: %,v
2008 %: RCS/%,v
2009 %: RCS/%
2010 %: s.%
2011 %: SCCS/s.%
2012
2013 -include ./Makefile.local
2014
2015 # vim: set noet :